<template>
  <div>
    <avue-form v-model="loneTreeNewForm" :option="option" v-if="flag == 'renonly'">
    </avue-form>
      <avue-form v-model="loneTreeNewForm" :option="this.options" @submit="submits" v-else-if="flag == 'edit'">
    </avue-form>
    <div>
<!--     编码规则-->
      <ThemeChildren
        ref="ThemeMasterChildren"
        dialogTitle="编码规则"
        codeName="codeRuleOidName"
        codeType="coderule"
        code-lcstatus="Released"
        :visible.sync="MasterdialogVisible"
        :SelectOption="SelectOption"
        :TreeAddform="loneTreeNewForm"
        @defineHandler="handlerDefine"
      ></ThemeChildren>
<!--      关键属性查询规则-->
      <ThemeChildren
        ref="ThemeKeyChildren"
        :SelectOption="SelectOption"
        :TreeAddform="loneTreeNewForm"
        :visible.sync="KeydialogVisible"
        code-lcstatus="Enabled"
        codeName="codeKeyAttrRepeatOidName"
        codeType="codekeyattrrepeat"
        dialogTitle="关键属性查询规则"
        @defineHandler="handlerDefine"
      ></ThemeChildren>
      <!--      相似项查询规则 codeResembleRuleOidName SimidialogVisible-->
      <ThemeChildren
        ref="ThemeSimChildren"
        :SelectOption="SelectOption"
        :TreeAddform="loneTreeNewForm"
        :visible.sync="SimidialogVisible"
        code-lcstatus="Enabled"
        codeName="codeResembleRuleOidName"
        codeType="coderesemblerule"
        dialogTitle="相似项查询规则"
        @defineHandler="handlerDefine"
      ></ThemeChildren>
<!--      存储的业务类型-->
      <ThemeChildren
        ref="ThemeBtmChildren"
        :SelectOption="btmSelectOption"
        :TreeAddform="loneTreeNewForm"
        :visible.sync="BtmdialogVisible"
        codeName="btmTypeName"
        codeType="btmCode"
        dialogTitle="业务类型"
        @defineHandler="handlerDefine"
      ></ThemeChildren>
    </div>
  </div>
</template>

<script>
import {defaultReferDataGrid,referDataGrid} from '@/api/MasterData/master'
import {TreeEditSave} from '@/api/template/templateAttr'
import ThemeChildren from '@/components/FormTemplate/ThemeChildren'
export default {
  components: {ThemeChildren},
  name: "classifyTreeform.vue",
  props: ['loneTreeNewForm','flag','Editclose','TreeFlag','nodeClickList'],
  data() {
    return {
      masterRow:null,
      masterInput:'',
      MasterSearchSelects:"",
      SelectOption:[
        {
          value: 'name',
          label: '中文名称'
        },
        {
          value: 'id',
          label: '英文名称'
        }
      ],
      btmSelectOption:[
        {
          value: 'id',
          label: '业务类型编号'
        },
        {
          value: 'name',
          label: '业务类型名称'
        },
      ],
      MasterdialogVisible:false,
      KeydialogVisible:false,
      SimidialogVisible:false,
      BtmdialogVisible:false,
      form: {
        name: "哈哈",
        sex: "男"
      },
      option: {
        submitBtn:false,
        emptyBtn:false,
        columnBtn:false,
        column: [
          {
            label: '主题库/分类编号',
            prop: 'id',
            labelWidth:135,
            disabled: true,
            rules: [{
              required: true,
              message: "主题库/分类编号",
              trigger: "blur"
            }]
          },
          {
            label: '主题库/分类名称',
            prop: 'name',
            disabled: true,
            labelWidth:135,
            rules: [{
              required: true,
              message: "主题库/分类名称",
              trigger: "blur"
            }]
          },
          {
            label:"描述",
            prop:"description",
            labelWidth:128,
            disabled: true,
          },
          {
            label: '存储的业务类型',
            prop: 'btmTypeName',
            labelWidth:128,
            disabled: true,
            rules: [{
              required: true,
              message: "存储的业务类型",
              trigger: "blur"
            }]
          },
          {
            label:"编码规则",
            prop:"codeRuleOidName",
            labelWidth:128,
            disabled: true,
          },
          {
            label:"关键属性查询规则",
            prop:"codeKeyAttrRepeatOidName",
            labelWidth:128,
            disabled: true,
          },
          {
            label:"相似查询规则",
            prop:"codeResembleRuleOidName",
            labelWidth:128,
            disabled: true,
          },
          {
            label: '是否参与关键属性校验',
            prop: 'isParticipateCheck',
            type: 'switch',
            activeColor: "#13ce66",
            inactiveColor: "#ff4949",
            labelWidth:160,
            disabled: true,
            dicData: [{
              label: '否',
              value: 0
            }, {
              label: '是',
              value: 1
            }
            ]
          }
        ]
      },

      FormList: {},
      masterSelectList:[],
      KeySelectLIst:[],
      simSelectList:[],
      btmSelectList:[]
    }
  },
  computed:{
    options(){
      return{
          column: [
            {
              label: '主题库/分类编号',
              prop: 'id',
              labelWidth:128,
              rules: [{
                required: true,
                message: "主题库/分类编号",
                trigger: "blur"
              }]
            },
            {
              label: '主题库/分类名称',
              prop: 'name',
              labelWidth:128,
              rules: [{
                required: true,
                message: "主题库/分类名称",
                trigger: "blur"
              }]
            },
            {
              label:"描述",
              prop:"description",
              labelWidth:128,
            },
            {
              label: '存储的业务类型',
              prop: 'btmTypeName',
              labelWidth:128,
              focus:this.btmFoucus,
                // readonly: true,
              display:this.TreeFlag,
              rules: [{
                required: true,
                message: "存储的业务类型",
                trigger: "blur"
              }]
            },
            {
              label:"编码规则",
              prop:"codeRuleOidName",
              labelWidth:128,
              focus:this.CodeFocus,
              readonly: true,
            },
            {
              label:"关键属性查询规则",
              prop:"codeKeyAttrRepeatOidName",
              labelWidth:128,
              focus:this.Keyfouce,
              readonly: true,
            },
            {
              label:"相似查询规则",
              prop:"codeResembleRuleOidName",
              labelWidth:128,
              focus: this.simFouce,
              readonly: true,
            },
            {
              label: '是否参与关键属性校验',
              prop: 'isParticipateCheck',
              type: 'switch',
              activeColor: "#13ce66",
              inactiveColor: "#ff4949",
              labelWidth:160,
              dicData: [{
                label: '否',
                value: 0
              }, {
                label: '是',
                value: 1
              }
              ]
            }
          ]

      }
    }
  },
  watch:{
    TreeFlag:{
      handler(newval,oldval){
        // console.log(newval)
      }
    }
  },
  created() {
  },
  methods: {
    //树编辑参照子组件事件
    handlerDefine(val) {
      const codeTypeMap = {
        coderule: {
          nameKey: 'codeRuleOidName',
          oidKey: 'codeRuleOid'
        },
        codekeyattrrepeat: {
          nameKey: 'codeKeyAttrRepeatOidName',
          oidKey: 'codeKeyAttrRepeatOid'
        },
        coderesemblerule: {
          nameKey: 'codeResembleRuleOidName',
          oidKey: 'codeResembleRuleOid'
        },
        btmCode: {
          nameKey: 'btmTypeName',
          oidKey: 'btmTypeId'
        }
      };

      const codeType = codeTypeMap[val.codeType];
      if (codeType) {
        this.$set(this.loneTreeNewForm, codeType.nameKey, val.crudName);
        this.$set(this.loneTreeNewForm, codeType.oidKey, val.crudOid);
        this.$emit('MasterHandler', this.loneTreeNewForm);
      }
    },
    submits(form,done){
      if(this.TreeFlag){
        TreeEditSave(this.loneTreeNewForm).then(res=>{
          this.$message.success('修改成功');
          this.Editclose()
          this.$emit('referTreeForm');
          this.$emit('flushed');
          done()
        })
      }else {
        this.loneTreeNewForm.btmTypeName='';
        this.loneTreeNewForm.btmTypeId='';
        TreeEditSave(this.loneTreeNewForm).then(res=>{
          this.$message.success('修改成功');
          this.Editclose()
          this.$emit('referTreeForm');
          this.$emit('flushed');
          done()
        })
      }
    },
    error(err) {
      this.$message.success(err);
    },
    //编码规则失焦
    CodeFocus(){
      this.MasterdialogVisible=true;
      this.$refs.ThemeMasterChildren.defaultSearchRend()
    },
    //关键属性失焦
    Keyfouce(){
      this.KeydialogVisible=true;
      this.$refs.ThemeKeyChildren.defaultSearchRend();
    },
    //相似项失焦
    simFouce(){
      this.SimidialogVisible=true;
      this.$refs.ThemeSimChildren.defaultSearchRend();
    },

    //业务类型失焦
    btmFoucus(){
      this.BtmdialogVisible = true;
      this.$refs.ThemeBtmChildren.btmDefaultRend();
    },
  }
}
</script>

<style scoped>

</style>
